base/urls.py
from django.conf import settings
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path, include, re_path, reverse_lazy
from django.views.generic import TemplateView
from django.views.static import serve

urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('logged_out/', TemplateView.as_view(template_name="registration/logged_out.html"), name="logged_out"),
    path('login/', LoginView.as_view(), name="login"),
    path('logout/', LogoutView.as_view(next_page=reverse_lazy("logged_out")), name="logout"),
    path('event/', include('event.urls')),
    path('rental/', include('rental.urls')),
    path('communication/', include('communication.urls')),
    path('i18n/', include('django.conf.urls.i18n')),
    path('', TemplateView.as_view(template_name="base/homepage.html"), name="homepage"),

]

if settings.DEBUG:
    urlpatterns.append(re_path(r'^media/(?P<path>.*)$',
                               serve,
                               {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}))

rental/urls.py
from django.urls import path

from rental.views import ItemDetailView, ItemListView, ItemActionView, ItemCreateView, ItemUpdateView

urlpatterns = [
    path("list/", ItemListView.as_view(), name="item_list"),
    path("create/", ItemCreateView.as_view(), name="item_create"),
    path("detail/<int:pk>/", ItemDetailView.as_view(), name="item_detail"),
    path("detail/<int:pk>/edit_form/", ItemUpdateView.as_view(), name="item_edit_form"),
    path("detail/<int:pk>/accept/<int:rental_pk>/", ItemActionView.as_view(action="accept"), name="item_accept"),
    path("detail/<int:pk>/rent/", ItemActionView.as_view(action="rent"), name="item_rent"),
    path("detail/<int:pk>/switch/", ItemActionView.as_view(action="switch"), name="item_switch"),
    path("detail/<int:pk>/edit/", ItemActionView.as_view(action="edit"), name="item_edit"),
    path("detail/<int:pk>/remove/", ItemActionView.as_view(action="remove", validate=True), name="item_remove")
]

rental/models.py
from django.db import models
from django.conf import settings
from django.utils.translation import gettext_lazy as _


class Items(models.Model):
    TYPES = (
        (1, _("Weapon")),
        (2, _("Armor")),
        (3, _("Shield")),
        (4, _("Equipment")),
        (5, _("Special")),
    )

    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, verbose_name=_("Owner"))
    name = models.CharField(max_length=30, verbose_name=_("Name"))
    type = models.IntegerField(choices=TYPES, verbose_name=_("Type"))
    image = models.ImageField(null=True, blank=True, verbose_name=_("Image"))
    description = models.TextField(max_length=300, verbose_name=_("Description"))
    is_available_for_rental = models.BooleanField(default=True, verbose_name=_("Is available for rental"))

    def __str__(self):
        return self.name


class ItemRental(models.Model):
    item = models.ForeignKey(Items, on_delete=models.SET_NULL, null=True, verbose_name=_("Item"))
    hirer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, verbose_name=_("Hirer"))
    created = models.DateTimeField(auto_now_add=True, verbose_name=_("Created"))
    fulfilled = models.BooleanField(default=False, verbose_name=_("Fulfilled"))

rental/forms.py
from django import forms

from rental.models import Items


class ItemCreateForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

    def save(self, commit=True):
        obj = super().save(commit=False)
        obj.owner = self.request.user
        obj.save(commit)
        return obj

    class Meta:
        model = Items
        fields = ("name", "type", "image", "description", "is_available_for_rental")


class ItemUpdateForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

    def save(self, commit=True):
        obj = super().save(commit=False)
        obj.owner = self.request.user
        obj.save(commit)
        return obj

    class Meta:
        model = Items
        fields = ("name", "type", "image", "description")

rental/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Q
from django.shortcuts import render
from django.urls import reverse
from django.utils.translation import gettext_noop
from django.views.generic import ListView, DetailView, RedirectView, CreateView, UpdateView

from rental.forms import ItemCreateForm, ItemUpdateForm
from rental.models import Items, ItemRental


class ItemListView(ListView):
    model = Items

    def get_queryset(self):
        qs = Q(is_available_for_rental=True)
        if self.request.user.is_authenticated:
            qs |= Q(owner=self.request.user)
        return super().get_queryset().filter(qs)


class ItemDetailView(DetailView):
    model = Items


class ItemCreateView(LoginRequiredMixin, CreateView):
    model = Items
    form_class = ItemCreateForm

    def get_success_url(self):
        return reverse("item_detail", kwargs={"pk": self.object.id})

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs["request"] = self.request
        return kwargs


class ItemUpdateView(LoginRequiredMixin, UpdateView):
    model = Items
    form_class = ItemUpdateForm

    def get_success_url(self):
        return reverse("item_detail", kwargs={"pk": self.object.id})

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs["request"] = self.request
        return kwargs


class ItemActionView(LoginRequiredMixin, RedirectView):
    action = None
    validate = False
    url = None

    def get_redirect_url(self, *args, **kwargs):
        return self.url or reverse("item_detail", kwargs={'pk': self.kwargs["pk"]})

    def apply_action(self, action):
        if action == gettext_noop("rent"):
            ItemRental.objects.create(hirer=self.request.user, item=self.item)
        elif action == gettext_noop("edit"):
            self.url = reverse("item_edit_form", kwargs={"pk": self.item.id})
        elif action == gettext_noop("accept"):
            rental = ItemRental.objects.get(id=self.kwargs["rental_pk"])
            rental.fulfilled = True
            rental.save(update_fields=["fulfilled"])
        elif action == gettext_noop("switch"):
            self.item.is_available_for_rental = not self.item.is_available_for_rental
            self.item.save(update_fields=["is_available_for_rental"])
        elif action == gettext_noop("remove"):
            self.item.delete()
            self.url = reverse("item_list")
        else:
            pass

    def get(self, request, *args, **kwargs):
        self.item = Items.objects.get(id=self.kwargs["pk"])
        if request.GET.get("valid") == 'false':
            return super().get(request, *args, **kwargs)
        elif self.validate and not request.GET.get("valid") == 'true':
            return render(request, "base/validate.html", {"object": self.item, "action": self.action})
        else:
            self.apply_action(self.action)
            return super().get(request, *args, **kwargs)

rental/templates/rental/items_detail.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "Items" %}
{% endblock %}
{% block body %}
    <div class="row">
        <div class="col-8">
            <div class="card">
                <div class="card-header">
                    {{ object.name }}
                    <span class="float-right">

                    {% if object.owner == request.user %}
                        <a class="btn btn-sm btn-primary" href="{% url "item_switch" pk=object.id %}"><small>
                            {% if object.is_available_for_rental %}
                                {% trans "Hide" %}
                            {% else %}
                                {% trans "Show" %}
                            {% endif %}
                        </small></a>
                        <a class="btn btn-sm btn-primary" href="{% url "item_remove" pk=object.id %}"><small>
                                {% trans "Remove" %}
                        </small></a>
                        <a class="btn btn-sm btn-primary" href="{% url "item_edit" pk=object.id %}"><small>
                                {% trans "Edit" %}
                        </small></a>
                    {% else %}
                        <a class="btn btn-sm btn-primary" href="{% url "item_rent" pk=object.id %}"><small>{% trans "Rent" %}</small></a>
                    {% endif %}
                    </span>

                </div>
                <div class="card-body">
                    <p>{% trans "Owner" %}:
                        {% if object.owner == request.user %}{% trans "Me" %}{% else %}{{ object.owner }}{% endif %}</p>
                    <p>{% trans "Type" %}: {{ object.get_type_display }}</p>
                    <p>{% trans "Description" %}: {{ object.description }}</p>
                </div>
                {% if object.image %}
                    <img class="card-img-bottom" src="{{ object.image.url }}">
                {% endif %}
            </div>
        </div>
        <div class="col-4">
            {% for rental in object.itemrental_set.all %}
                <div class="card">
                    <div class="card-body">
                        {% if rental.fulfilled %}
                            <p>{% trans "Rented by" %}: {{ rental.hirer }}</p>
                        {% else %}
                            <p>{% trans "Requested by" %}: {{ rental.hirer }}
                                {% if object.owner == request.user %}
                                    <a class="btn btn-sm btn-primary"
                                       href="{% url "item_accept" pk=object.id rental_pk=rental.id %}">{% trans "Accept" %}</a>
                                {% endif %}
                            </p>
                        {% endif %}
                        <p>{% trans "Date" %}: {{ rental.created }}</p>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
{% endblock %}

rental/templates/rental/items_form.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "New Item" %}
{% endblock %}
{% block body %}
    <div class="row">
        <div class="col-4 offset-4">
            <form method="POST" enctype="multipart/form-data">
                {% csrf_token %}
                {% bootstrap_form form %}
                {% trans "Create" as btn_content %}
                {% bootstrap_button content=btn_content button_type="submit" button_class="btn-primary btn-block" %}
            </form>
        </div>
    </div>
{% endblock %}

rental/templates/rental/items_list.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "Items" %}
{% endblock %}
{% block body %}
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-1 offset-11">
                    <a class="btn btn-secondary btn-sm" href="{% url "item_create" %}">{% trans "Create" %}</a>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="row">
        {% for item in object_list %}
            <div class="col-3">
                <div class="card">
                    <div class="card-header {% if item.owner == request.user %}bg-secondary{% endif %}">
                        <a href="{% url "item_detail" pk=item.id %}">{{ item.name }}</a>
                    </div>
                    {% if item.image %}
                        <img class="card-img-top" src="{{ item.image.url }}">
                    {% endif %}
                    <div class="card-body">
                        <p>{% trans "Owner" %}:
                            {% if item.owner == request.user %}{% trans "Me" %}{% else %}{{ item.owner }}{% endif %}</p>
                        <p>{% trans "Type" %}: {{ item.get_type_display }}</p>
                        <p>{% trans "Description" %}: {{ item.description }}</p>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}